# PACKAGES ncessaires
library(dplyr)    # Utilitaires


# EXEMPLE aide en LIGNE  : Slection de variables

data(iris)
iris = tbl_df(iris) # Pour amliorer l impression

# Colonnes selectionnees 
X1=select(iris, starts_with("Petal"))
X2=select(iris, ends_with("Width"))
X3=select(iris, contains("etal"))
X4=select(iris, matches(".t."))
X5=select(iris, Petal.Length, Petal.Width)

vars <- c("Petal.Length", "Petal.Width")
X6=select(iris, one_of(vars))

# Colonnes supprimes
X1=select(iris, -starts_with("Petal"))
X2=select(iris, -ends_with("Width"))
X3=select(iris, -contains("etal"))
X4=select(iris, -matches(".t."))
X5=select(iris, -Petal.Length, -Petal.Width)




# mutate : Cration de variables


# filter : Slection



df <- as.data.frame(matrix(runif(100), nrow = 10))
df <- tbl_df(df[c(3, 4, 7, 1, 9, 8, 5, 2, 6, 10)])
select(df, V4:V6)
select(df, num_range("V", 4:6))

# Rordonner les colonnes
X1=select(iris, Species, everything())

# slice : Extraction lignes
slice(deces,1)        # Premiere ligne
slice(deces, n())     # Derniere ligne
X1=slice(deces, 5:10) # Lignes 5  10

# Rsum du data frame
glimpse(deces)

# PARCOURIR les DONNEES
deces %>% View()

# FILTRER les DONNEES
dec_FERR      = deces %>% filter(PAROISSE == "Ferrires")
dec_FERR_1710 = deces %>% 
  filter(PAROISSE == "Ferrires", DECES_A=="1710")

# Idem avec SELECTION de VARIABLES
dec_FERR_1710 = deces %>% 
  filter(PAROISSE == "Ferrires", DECES_A=="1710") %>% 
  select(NOM, PRENOM, Age_Deces, starts_with("DECES_"))

# Idem en TRIANT par MOIS DE DECES
dec_FERR_1710 = deces %>% 
  filter(PAROISSE == "Ferrires", DECES_A=="1710") %>% 
  select(NOM, PRENOM, Age_Deces, starts_with("DECES_")) %>%
  arrange(DECES_M)   # ATTENTION


# Nombre de DECES PAR par AGE
Res_D = deces %>%
  group_by(Age_Deces) %>%
  summarise(Nbdec = n())

#  Fichier RECENSEMENT

# Nombre de personnes par MENAGE + Stats
Rec02_M = rec1702 %>%
  group_by(CM_ID) %>%
  summarise(Nbpers = n(), 
            AgeMin=min(Age_N,na.rm=T),
            AgeMax=max(Age_N,na.rm=T))


# Dfinir de NOUVELLES VARIABLES

# Nombre ADULTES par MENAGE
Rec02_M = rec1702 %>%
  mutate(adulte=(Age_N>20)) %>%
  group_by(CM_ID) %>%
  summarise(Nbpers = n(), 
            NbADU = sum(adulte,na.rm=T))






