# PACKAGES ncessaires
library(plyr)    # Utilitaires
library(ggplot2) # Graphiques

# Tri par ordre descendant
x=arrange(prenom_wt,desc(COUNT))

# Lecture fichier CSV 
setwd("D:/Bureau/Projet EN COURS/RUSS/Donnes")
rec1702=read.csv("rec1702.csv", sep=";", stringsAsFactors = F)
rec1702$nom_prenom=paste(rec1702$Nom,rec1702$Prenom,sep=" ") 
rec1702$Age_N=as.integer(rec1702$Age)

# Nettoyage des donnes
rec1702=subset(rec1702,Sexe %in% c("M","F"))

# Tri par plusieurs variables
x=arrange(rec1702,Paroisse,Rue)

# Count number of missing values
nmissing <- function(x) sum(is.na(x))

# Apply to every column in a data frame
colwise(nmissing)(rec1702)

# Distributions
count(rec1702,"Age_N")
X=count(rec1702,c("Paroisse","Age_N"))

# Graphique
ggplot(X, aes(x=Age_N, y=freq))+
  geom_bar(stat="Identity")+
  facet_grid(Paroisse~.)


# Statistiques agrges
X=ddply(rec1702,
        .(Paroisse,Sexe),
        summarize,
        agemoy=mean(Age_N,na.rm=T))

# Idem stockes au NIVEAU INDIVIDUEL
X=ddply(rec1702,
        .(Paroisse,Sexe),
        mutate,
        agemoy=mean(Age_N,na.rm=T))

# Nombre HABITANTS par Paroisse
X=ddply(rec1702,
        ~Paroisse,
        nrow)

# Nombre HABITANTS par RUE
X=ddply(rec1702,
        ~Paroisse+Rue,
        nrow)


# Nombre DECES par AN par PAROISSE

# Lecture fichier CSV 
setwd("D:/Bureau/Projet EN COURS/RUSS/Donnes")
deces=read.csv("BMS_Deces.csv", sep=";", stringsAsFactors = F)

# Traitement de donnes
deces$Age_Deces=as.integer(deces$AGE_ANNEES)
deces[which(deces$AGE_MOIS != ""),"Age_Deces"]=0
deces[which(deces$AGE_JOURS != ""),"Age_Deces"]=0

# Nombre DE DECES PAR Paroisse, par AGES par AN
X=ddply(deces,
        ~PAROISSE+Age_Deces+DECES_A,
        nrow)

# Graphique
ggplot(subset(X,Age_Deces==0), aes(x=DECES_A, y=V1))+
  geom_bar(stat="Identity")+
  facet_grid(PAROISSE~.)


# AUTRES FONCTIONNALITES 

# Recodages
rec1702$Sexe=revalue(rec1702$Sexe,c("2"="F","M "="M"))

# Autre syntaxe
from=c("18","19","20")
to=c("18-20","18-20","18-20")
rec1702$Age=mapvalues(rec1702$Age,from,to)


# Selection des habitants VIVANT dans un MENAGE au plus de 3 personnes
tmen=subset(count(rec1702,"CM_ID"),freq<4)
tind_m3=match_df(rec1702,tmen,on="CM_ID")

# Renommer les COLONNES
rec1702=rename(rec1702,c("Origine"="Lieu origine"))
                 