# PACKAGES ncessaires
library(stringr)   # Fonctions CHAINES de CARACTERE

# Tous les prnoms contenant "ean"
str_subset(prenom_wt$PRENOM, "ean")

# Dtection de PATTERNS
pattern="a.+b"
strings=c("abc", "azzb")
str_detect(strings, pattern)

# Dtections de MOTS
words=c("These are          some words.")
str_count(words, boundary("word"))
X1=str_split(words, " ")[[1]]
X2=str_split(words, boundary("word"))[[1]]

# Extraction de chaines
str_extract_all("The Cat in the Hat", "[a-z]+")
str_extract_all("The Cat in the Hat", "[a-z ]+")
str_extract_all("The Cat in the Hat", regex("[a-z]+", ignore_case=TRUE))

# Gestion CASSE des caractres
str_to_lower("CAT")
X=str_to_upper("bring")
str_to_lower(X)
str_to_title(X)

# Extraction de SOUS-CHAINES PREDEFINIES
numbers="1 and 2 and 4 and 456"
num_loc=str_locate_all(numbers, "[0-9]+")[[1]]
num_loc
str_sub(numbers, num_loc[, "start"], num_loc[, "end"])
text_loc=invert_match(num_loc)
str_sub(numbers, text_loc[, "start"], text_loc[, "end"])

# Concatnation de CHAINES
paste("Letter: ", letters)
str_c("Letter: ", letters)
str_c(letters[-26], " comes before ", letters[-1])
str_c(letters, collapse = "")

# Duplication de CHAINES
fruit=c("apple", "pear", "banana")
str_dup(fruit, 2)
str_dup(fruit, 1:3)

# Localisation MOTIFS
fruit=c("apple", "Banana", "pear", "pineapple")
str_locate(fruit, "[A-Z]")
str_locate(fruit, "a")
str_locate(fruit, "e")
str_locate(fruit, c("a", "b", "p", "p"))

# Extractions SOUS CHAINES
str_match(fruit, "a..")
str_match_all(fruit, "a")
str_extract(fruit, "a..")
str_extract(fruit,"^a.+")
str_extract_all(fruit, "a")

# Longueur SOUS CHAINES
str_length(fruit)

# Ordonner les ELEMENTS
fruit[str_order(fruit,decreasing =T)]

# Chaines de longueur FIXE
str_pad(fruit,6)
str_pad(fruit,6,"right")


# Dcoupage CHAINE

fruits <- c("apples and oranges and pears and bananas",
            "pineapples and mangos and guavas")

# Indication du SEPARATEUR
str_split(fruits, " and ")
str_split(fruits, " and ", simplify=T)

# FIXED implique MATRIX
str_split_fixed(fruits, " and ", 3)

# Nettoyage TRIMMING espaces
str_trim("  String with trailing and leading white space      ")


# Extraction SOUS CHAINES
hw="Hadley Wickham"

str_sub(hw, 1, 6)
str_sub(hw, end = 6)
str_sub(hw, 8, 14)
str_sub(hw, 8)
str_sub(hw, c(1, 8), c(6, 14))

# Indices Ngatifs 
str_sub(hw, -1)
str_sub(hw, -7)
str_sub(hw, end = -7)


# Remplacement de SOUS CHAINES
x <- "BBCDEF"
str_sub(x, 1, 1)="A" ; x
str_sub(x, -1, -1)="K" ; x
str_sub(x, -2, -2)="GHIJ" ; x
str_sub(x, 2, -2)="" ; x

# Extraction de tous les lments qui satisfont la CONDTION
fruit= c("apple", "banana", "pear", "pinapple")
str_subset(fruit, "a")
str_subset(fruit, "^a")
str_subset(fruit, "a$")
str_subset(fruit, "b")
str_subset(fruit, "[eiou]")
